'use strict';

exports.__esModule = true;
exports.resizeWindow = exports.takeScreenshot = exports.closeTab = exports.getClientInfo = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var getActiveTab = function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(cdpPort, browserId) {
        var tabs, tab;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.next = 2;
                        return _chromeRemoteInterface2.default.listTabs({ port: cdpPort });

                    case 2:
                        tabs = _context.sent;
                        tab = tabs.filter(function (t) {
                            return t.type === 'page' && t.url.indexOf(browserId) > -1;
                        })[0];
                        return _context.abrupt('return', tab);

                    case 5:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    return function getActiveTab(_x, _x2) {
        return _ref.apply(this, arguments);
    };
}();

var getWindowId = function () {
    var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(client, tab) {
        var _ref3, windowId;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        _context2.prev = 0;
                        _context2.next = 3;
                        return client.Browser.getWindowForTarget({ targetId: tab.id });

                    case 3:
                        _ref3 = _context2.sent;
                        windowId = _ref3.windowId;
                        return _context2.abrupt('return', windowId);

                    case 8:
                        _context2.prev = 8;
                        _context2.t0 = _context2['catch'](0);
                        return _context2.abrupt('return', null);

                    case 11:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, this, [[0, 8]]);
    }));

    return function getWindowId(_x3, _x4) {
        return _ref2.apply(this, arguments);
    };
}();

var setEmulationBounds = function () {
    var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(client, device, newDimensions) {
        var width, height;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        width = newDimensions ? newDimensions.width : device.width;
                        height = newDimensions ? newDimensions.height : device.height;
                        _context3.next = 4;
                        return client.Emulation.setDeviceMetricsOverride({
                            width: width,
                            height: height,
                            deviceScaleFactor: device.scaleFactor,
                            mobile: device.mobile,
                            fitWindow: true
                        });

                    case 4:
                        _context3.next = 6;
                        return client.Emulation.setVisibleSize({ width: width, height: height });

                    case 6:
                    case 'end':
                        return _context3.stop();
                }
            }
        }, _callee3, this);
    }));

    return function setEmulationBounds(_x5, _x6, _x7) {
        return _ref4.apply(this, arguments);
    };
}();

var setEmulation = function () {
    var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(client, device) {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
            while (1) {
                switch (_context4.prev = _context4.next) {
                    case 0:
                        if (!(device.userAgent !== void 0)) {
                            _context4.next = 3;
                            break;
                        }

                        _context4.next = 3;
                        return client.Network.setUserAgentOverride({ userAgent: device.userAgent });

                    case 3:
                        if (!(device.touch !== void 0)) {
                            _context4.next = 6;
                            break;
                        }

                        _context4.next = 6;
                        return client.Emulation.setTouchEmulationEnabled({
                            enabled: device.touch,
                            configuration: device.mobile ? 'mobile' : 'desktop'
                        });

                    case 6:
                        _context4.next = 8;
                        return setEmulationBounds(client, device);

                    case 8:
                    case 'end':
                        return _context4.stop();
                }
            }
        }, _callee4, this);
    }));

    return function setEmulation(_x8, _x9) {
        return _ref5.apply(this, arguments);
    };
}();

var getClientInfo = exports.getClientInfo = function () {
    var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(browserId, _ref7) {
        var config = _ref7.config,
            cdpPort = _ref7.cdpPort;
        var tab, client, windowId;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
            while (1) {
                switch (_context5.prev = _context5.next) {
                    case 0:
                        _context5.prev = 0;
                        _context5.next = 3;
                        return getActiveTab(cdpPort, browserId);

                    case 3:
                        tab = _context5.sent;

                        if (tab) {
                            _context5.next = 6;
                            break;
                        }

                        return _context5.abrupt('return', {});

                    case 6:
                        _context5.next = 8;
                        return (0, _chromeRemoteInterface2.default)({ target: tab, port: cdpPort });

                    case 8:
                        client = _context5.sent;
                        _context5.next = 11;
                        return getWindowId(client, tab);

                    case 11:
                        windowId = _context5.sent;
                        _context5.next = 14;
                        return client.Page.enable();

                    case 14:
                        _context5.next = 16;
                        return client.Network.enable();

                    case 16:
                        if (!config.emulation) {
                            _context5.next = 19;
                            break;
                        }

                        _context5.next = 19;
                        return setEmulation(client, config);

                    case 19:
                        return _context5.abrupt('return', { tab: tab, client: client, windowId: windowId });

                    case 22:
                        _context5.prev = 22;
                        _context5.t0 = _context5['catch'](0);
                        return _context5.abrupt('return', {});

                    case 25:
                    case 'end':
                        return _context5.stop();
                }
            }
        }, _callee5, this, [[0, 22]]);
    }));

    return function getClientInfo(_x10, _x11) {
        return _ref6.apply(this, arguments);
    };
}();

var closeTab = exports.closeTab = function () {
    var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(_ref10) {
        var tab = _ref10.tab,
            cdpPort = _ref10.cdpPort;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
            while (1) {
                switch (_context6.prev = _context6.next) {
                    case 0:
                        _context6.next = 2;
                        return _chromeRemoteInterface2.default.closeTab({ id: tab.id, port: cdpPort });

                    case 2:
                    case 'end':
                        return _context6.stop();
                }
            }
        }, _callee6, this);
    }));

    return function closeTab(_x12) {
        return _ref9.apply(this, arguments);
    };
}();

var takeScreenshot = exports.takeScreenshot = function () {
    var _ref11 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(path, _ref12) {
        var client = _ref12.client,
            config = _ref12.config;
        var screenshot;
        return _regenerator2.default.wrap(function _callee7$(_context7) {
            while (1) {
                switch (_context7.prev = _context7.next) {
                    case 0:
                        _context7.next = 2;
                        return client.Page.captureScreenshot({ fromSurface: config.headless });

                    case 2:
                        screenshot = _context7.sent;
                        _context7.next = 5;
                        return (0, _promisifiedFunctions.writeFile)(path, screenshot.data, { encoding: 'base64' });

                    case 5:
                    case 'end':
                        return _context7.stop();
                }
            }
        }, _callee7, this);
    }));

    return function takeScreenshot(_x13, _x14) {
        return _ref11.apply(this, arguments);
    };
}();

var resizeWindow = exports.resizeWindow = function () {
    var _ref13 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(newDimensions, currentDimensions, _ref14) {
        var config = _ref14.config,
            client = _ref14.client,
            windowId = _ref14.windowId;
        var newWidth, newHeight, currentWidth, currentHeight, bounds;
        return _regenerator2.default.wrap(function _callee8$(_context8) {
            while (1) {
                switch (_context8.prev = _context8.next) {
                    case 0:
                        newWidth = newDimensions.width;
                        newHeight = newDimensions.height;
                        currentWidth = currentDimensions.width;
                        currentHeight = currentDimensions.height;

                        if (!(config.emulation || !windowId && config.headless)) {
                            _context8.next = 8;
                            break;
                        }

                        _context8.next = 7;
                        return setEmulationBounds(client, config.device, { width: newWidth, height: newHeight });

                    case 7:
                        return _context8.abrupt('return');

                    case 8:
                        if (windowId) {
                            _context8.next = 10;
                            break;
                        }

                        return _context8.abrupt('return');

                    case 10:
                        _context8.next = 12;
                        return client.Browser.getWindowBounds({ windowId: windowId });

                    case 12:
                        bounds = _context8.sent;


                        bounds.width += newWidth - currentWidth;
                        bounds.height += newHeight - currentHeight;

                        _context8.next = 17;
                        return client.Browser.setWindowBounds({ windowId: windowId, bounds: bounds });

                    case 17:
                    case 'end':
                        return _context8.stop();
                }
            }
        }, _callee8, this);
    }));

    return function resizeWindow(_x15, _x16, _x17) {
        return _ref13.apply(this, arguments);
    };
}();

exports.isHeadlessTab = isHeadlessTab;

var _chromeRemoteInterface = require('chrome-remote-interface');

var _chromeRemoteInterface2 = _interopRequireDefault(_chromeRemoteInterface);

var _promisifiedFunctions = require('../../../../utils/promisified-functions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isHeadlessTab(_ref8) {
    var tab = _ref8.tab,
        config = _ref8.config;

    return tab && config.headless;
}